#
# spec file for package hplip (Version 1.6.6a)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# neededforbuild  blt cups cups-client cups-devel cups-libs foomatic-filters kde3-devel-packages kdebindings3-python libusb net-snmp net-snmp-devel perl-TermReadKey pkgconfig python python-devel python-openssl python-tk python-xml qscintilla readline-devel resmgr sane tcl tk

BuildRequires:  aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc libnscd libselinux libstdc++ libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel arts arts-devel autoconf automake binutils blt cups cups-client cups-devel cups-libs expat fam fam-devel fontconfig fontconfig-devel foomatic-filters freeglut freeglut-devel freetype2 freetype2-devel gcc gcc-c++ gdbm gettext glib2 glib2-devel gnome-filesystem jack jack-devel kdebindings3-python kdelibs3 kdelibs3-devel kdelibs3-doc libart_lgpl libart_lgpl-devel libgcrypt libgcrypt-devel libgpg-error libgpg-error-devel libidn libidn-devel libjpeg libjpeg-devel liblcms liblcms-devel libmng libmng-devel libpng libpng-devel libstdc++-devel libtiff libtiff-devel libtool libusb libxml2 libxml2-devel libxslt libxslt-devel net-snmp net-snmp-devel openssl-devel pcre pcre-devel perl perl-TermReadKey pkgconfig python python-devel python-openssl python-tk python-xml qscintilla qt3 qt3-devel readline-devel resmgr rpm sane tcl tk unsermake update-desktop-files xorg-x11-Mesa xorg-x11-Mesa-devel xorg-x11-devel xorg-x11-libs

Name:           hplip
Summary:        HP's Printing and Scanning Software
# HPLIP has reached 1.0 status. With this release a date encoded revision number is used:
# x.y.m : x = major release number, y = year (eg: 6 = 2006), m = month (eg: 6a = second release in June)
# Official releases have a 3 digit number and release candidates have a 4 digit number: x.y.m.rc
Version:        1.6.6a
Release:        0.1
%define hpijsVersion 2.6.6
Group:          Hardware/Printing
License:        GPL, X11/MIT
URL:            http://hpinkjet.sourceforge.net/
# URL for Source0: http://superb-west.dl.sourceforge.net/sourceforge/hplip/hplip-1.6.6a.tar.gz
Source0:        %{name}-%{version}.tar.bz2
# Fix "... is used uninitialized ..." warnings:
Patch10:        fix-uninitialized-variables.diff
# Change installation directory for PPDs:
Patch11:        change-ppd-install-dir.diff
# Change installation directory for the documentation:
Patch12:        change-doc-install-dir.diff
# Source100 is the primary source for the suse_update_desktop_file stuff.
# It is found automatically in $RPM_SOURCE_DIR by 'suse_update_desktop_file -i hplip':
Source100:      %{name}.desktop
# Source101 is a wrapper for hp-toolbox which shows meaningful error messages even under X.
# hp-toolbox.wrapper is called via hplip.desktop.
Source101:      hp-toolbox.wrapper
# Source102 is a small man page for /usr/bin/hpijs:
Source102:      hpijs.1.gz
# Patch100 changes the init script after it was installed:
Patch100:       %{name}-init-script.diff
# Install into this non-root directory (required when norootforbuild is used):
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         coreutils, /bin/grep, /bin/sed
Requires:       %{name}-hpijs, foomatic-filters, python-xml, kdebindings3-python
# Skip testing devel dependencies required by libtool .la files by the following comment:
# skip-check-libtool-deps

%description
The Hewlett-Packard Linux Imaging and Printing project (HPLIP) provides
a unified single and multifunction connectivity solution for HP
printers and scanners (in particular, HP all-in-one devices).

HPLIP provides unified connectivity for printing, scanning, photo card
access, and device management and is designed to work with CUPS. It
includes the Ghostscript printer driver HPIJS for HP printers and a
special "hp" CUPS backend that provides bidirectional communication
with the device (required for HP printer device management). It also
includes the SANE scanner backend "hpaio" for HP all-in-one devices.
The "hp-toolbox" program is provided for device management.

The HPLIP project is open source software and uses GPL-compatible
licenses. For more information see:

http://hpinkjet.sourceforge.net/

/usr/share/doc/packages/hplip/hplip_readme.html

/usr/share/doc/packages/hplip/hpijs-*/hpijs_readme.html



Authors:
--------
    David Suffield <david.suffield@hp.com>
    Cory Meisch <cory.meisch@hp.com>
    Yie Shiyun <shiyun.yie@hp.com>
    Donald J. Welch <donald.welch@hp.com>

%debug_package
%package hpijs
Summary:        HPIJS for HP's printing and scanning software HPLIP.
Group:          Hardware/Printing
Requires:       ghostscript_any

%description hpijs
HPIJS is a Ghostscript printer driver for HP printers.

This sub-package includes only the plain HPIJS binary. Normally (in
particular for CUPS) HPIJS needs the rest of HP's printing and scanning
software in the package hplip. For special cases (e.g. for
LPRng/lpdfilter) it is possible to use only the plain HPIJS binary and
Ghostscript.

For documentation and license see the main-package hplip.



Authors:
--------
    David Suffield <david.suffield@hp.com>
    Cory Meisch <cory.meisch@hp.com>
    Yie Shiyun <shiyun.yie@hp.com>
    Donald J. Welch <donald.welch@hp.com>

%prep
# Be quiet when unpacking:
%setup -q
# Fix "... is used uninitialized ..." warnings:
%patch10
# Change installation directory for PPDs:
%patch11
# Change installation directory for the documentation:
%patch12

%build
# If AUTOMAKE='automake --foreign' is not set, autoreconf (in fact automake)
# complains about missing files like NEWS, README, AUTHORS, ChangeLog
# in each directory where a Makefile.am exists:
AUTOMAKE='automake --foreign' autoreconf --force --install
# Set our preferred architecture-specific flags for the compiler and linker:
export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
# Regarding the configure options see tech_docs/tarball_install.html (not very explanatory):
# --disable-rpm-install      disables sane, icon, /etc/hp and /etc/init.d install (default = disabled)
# --disable-foomatic-install disables foomatic install (HPIJS option, default = enabled)
# --disable-cups-install     disables cups install (HPIJS option, default = enabled)
#                            CUPS install would do:
#                            (1) remove any old HP HPIJS PPD files from the CUPS PPD directory
#                            (2) symlink the HP HPIJS PPD files to the CUPS PPD directory
#                            (3) symlink foomatic-rip to the CUPS filter directory.
# --disable-network-build    disables network support, will not link with libsnmp (default = enabled)
# --disable-pp-build         disables parallel port support (default = enabled)
# rpm-install is no longer needed because "make install DESTDIR=/tmp/myhplip" works correctly now.
# disable-cups-install avoids useless stuff when building a RPM.
./configure --prefix=/usr --libdir=%_libdir --disable-cups-install
make

%install
make install DESTDIR=%{buildroot}
# Remove the installed /etc/sane.d/dll.conf
# because this is provided by the sane package:
rm %{buildroot}%{_sysconfdir}/sane.d/dll.conf
# Move /usr/lib/libsane-hpaio.* to where SANE expects them:
mv -f %{buildroot}%{_libdir}/libsane-hpaio.* %{buildroot}%{_libdir}/sane/
# Remove the installed /usr/bin/foomatic-rip
# because this is provided by the foomatic-filters package:
rm %{buildroot}%{_bindir}/foomatic-rip
# Exchange the non-working and deactivated "killall -HUP cupsd" line:
patch %{buildroot}%{_initrddir}/%{name} %{PATCH100}
# Add the usual 'rc'-link to the runlevel script:
install -d %{buildroot}%{_sbindir}
ln -s ../..%{_initrddir}/%{name} %{buildroot}%{_sbindir}/rc%{name}
# Make some general tests and adjustments for all PPDs (see manufacturer-PPDs.spec):
pushd %{buildroot}%{_datadir}/cups/model/manufacturer-PPDs/%{name}
gunzip *.ppd.gz
# Correct or remove non-working PPDs:
# Several HP PPDs contain "600x600x2dpi" which is not allowed
# according to the Adobe PPD specification section 5.9
# and which can be simply replaced by "600x1200dpi"
# because "600x1200dpi" is not used elsewhere in the PPD.
# Some PPDs contain a "*cupsFilter: ... hppostprocessing" line
# which cannot work because there is no "hppostprocessing" filter.
for p in *.ppd
do perl -pi -e 's/600x600x2dpi/600x1200dpi/;' $p
   grep -q '^\*cupsFilter:.*hppostprocessing' $p && rm -v $p
done
# HP_LaserJet_5Si.ppd works only when this printer has the optional PostScript module:
sed -i -e '/^\*NickName:/s/ (recommended)//' HP_LaserJet_5Si.ppd
sed -i -e '/^\*ModelName:/s/5Si/5Si MX/' HP_LaserJet_5Si.ppd
# HP_LaserJet_5MP.ppd works only for the model with the built-in PostScript module ("MP"):
sed -i -e '/^\*ModelName:/s/5P/5MP/' HP_LaserJet_5MP.ppd
# Change default media size to A4 if this is an available choice in the PPD and then
# set DefaultPageSize, DefaultPageRegion, DefaultImageableArea, DefaultPaperDimension to A4:
for p in *.ppd
do for i in PageSize PageRegion ImageableArea PaperDimension
   do if grep -q "^\*$i[[:space:]]*A4[:/]" $p
      then grep -q "^\*Default$i:[[:space:]]*A4\$" $p || perl -pi -e "s/^\*Default$i:.*/\*Default$i: A4/" $p
      fi
   done
done
# Final test by cupstestppd:
# Only keep files which don't FAIL for cupstestppd.
# To save disk space gzip the files (gzipped PPDs can also be used by CUPS):
for p in *.ppd
do cupstestppd $p || { rm -v $p ; continue ; }
   gzip $p
done
popd
# End of the general tests and adjustments for all PPDs.
# Desktop menue entry stuff:
# Install the wrapper for hp-toolbox:
install -m 755 %{SOURCE101} %{buildroot}%{_bindir}/hp-toolbox.wrapper
# Install /usr/share/hplip/data/images/HPmenu.png as desktop icon file:
install -d %{buildroot}%{_datadir}/pixmaps
install -m 644 %{buildroot}%{_datadir}/%{name}/data/images/HPmenu.png %{buildroot}%{_datadir}/pixmaps/HPmenu.png
# Set up and install the desktop menue entry stuff using "Categories=System;Monitor;"
# and remove HP's hplip.desktop file before because we use Source100:
rm %{buildroot}%{_datadir}/applications/%{name}.desktop
%suse_update_desktop_file -i %{name} System Monitor
# Install the man page for /usr/bin/hpijs:
install -d %{buildroot}%{_mandir}/man1
install -m 644 %{SOURCE102} %{buildroot}%{_mandir}/man1/

%post
/sbin/ldconfig
exit 0

%triggerin -- sane
# As hplip can be used for plain printers it cannot "PreReq sane".
# Therefore if sane is installed it may be installed or updated after hplip.
# In this case trigger to add the SANE backend "hpaio" to /etc/sane.d/dll.conf if it is not there.
# To be safe there is a test that /etc/sane.d/dll.conf is writable.
if [ -w /etc/sane.d/dll.conf ]
then grep -q 'hpaio' /etc/sane.d/dll.conf || echo -e '# The hpaio backend is provided by the hplip package:\n#hpaio' >>/etc/sane.d/dll.conf
fi
exit 0

%postun 
/sbin/ldconfig
# If the package was removed (but not if it was updated)
# then remove the hpaio lines in /etc/sane.d/dll.conf.
# The "exit 0" is necessary, otherwise the postun script
# would exit with non-zero exit-code if the package was not removed.
# Note that sane may not be installed (see triggerin)
# and therefore the test that /etc/sane.d/dll.conf is writable.
if [ "$1" = "0" ]
then [ -w /etc/sane.d/dll.conf ] && sed -i -e '/hpaio/d' /etc/sane.d/dll.conf
fi
exit 0

%files
%defattr(-, root, root)
%config %{_sysconfdir}/hp/
%{_initrddir}/%{name}
%{_sbindir}/rc%{name}
%{_datadir}/%{name}/
%{_sbindir}/hpiod
%{_bindir}/hp-toolbox
%{_bindir}/hp-align
%{_bindir}/hp-check
%{_bindir}/hp-clean
%{_bindir}/hp-colorcal
%{_bindir}/hp-fab
%{_bindir}/hp-info
%{_bindir}/hp-levels
%{_bindir}/hp-makecopies
%{_bindir}/hp-makeuri
%{_bindir}/hp-print
%{_bindir}/hp-sendfax
%{_bindir}/hp-setup
%{_bindir}/hp-testpage
%{_bindir}/hp-unload
%{_libdir}/python%{py_ver}/site-packages/cupsext.so
%{_libdir}/python%{py_ver}/site-packages/pcardext.so
%dir %{_libdir}/cups
%dir %{_libdir}/cups/backend
%{_libdir}/cups/backend/hp
%{_libdir}/cups/backend/hpfax
%dir %{_libdir}/sane
%{_libdir}/sane/libsane-hpaio.*
%dir %{_datadir}/cups
%dir %{_datadir}/cups/model
%dir %{_datadir}/cups/model/manufacturer-PPDs
%{_datadir}/cups/model/manufacturer-PPDs/%{name}/
%doc %{_defaultdocdir}/%{name}/
%{_bindir}/hp-toolbox.wrapper
%{_datadir}/pixmaps/HPmenu.png
%{_datadir}/applications/%{name}.desktop
%doc %{_mandir}/man1/hpijs.1.gz

%files hpijs
%defattr(-, root, root)
%{_bindir}/hpijs
%{_libdir}/libhpip.*

%changelog -n hplip
* Wed Jun 28 2006 - jsmeix@suse.de
- Updated to maintenance release 1.6.6a:
  This provides various minor fixes and enhancements.
  For details see doc/release_notes.html in the source
  or /usr/share/doc/packages/hplip/release_notes.html
* Mon Jun 19 2006 - jsmeix@suse.de
- Updated to version 1.6.6:
  HPLIP has reached 1.0 status.
  With this release a date encoded revision number x.y.m is used:
  x = major release number, y = year (6=2006), m = month (6=June)
  Correct URLs in HTML docs (obsoletes fix-doc-hrefs.diff).
  Removed DeviceOpen from hp backend. This fixes two problems:
  1) usblp will no longer be removed for device discovery
  2) device discovery will no longer cause Inkjets to power-up.
  Added hpaio.desc file for SANE.
  Several more supported printers.
- Cleaned up build (simplified spec file):
  Changed install dir for PPDs and doc in Makefile.am.
  Using configure without rpm-install.
  Using configure with --disable-cups-install.
  Links to work around inconsistent naming of python scripts
  and links to hpfax backend and its associated PPD file
  are no longer needed.
* Fri Jun 09 2006 - jsmeix@suse.de
- Added man page for /usr/bin/hpijs (hpijs.1.gz).
- Fixed wrong URLs in HTML documentation (fix-doc-hrefs.diff).
- Added links to work around inconsistent naming of python scripts.
- Added links to hpfax backend and its associated PPD file
  to make them available as usual for CUPS setup tools.
* Mon May 22 2006 - jsmeix@suse.de
- Fixed typo (missing '"') in hplip-init-script.diff
* Fri May 19 2006 - jsmeix@suse.de
- Updated to version 0.9.11:
  Revised and updated documentation.
  Some more supported all-in-one devices and printers.
  Several bug fixes (no Suse bugs).
- Updated to version 0.9.10:
  Several bug fixes (no Suse bugs).
- Updated to version 0.9.9:
  Uses libusb for all USB I/O.
  CUPS USB DeviceURIs must be changed from
  "hp:/hp_model?device=/dev/usb/lpX" (no longer supported)
  to "hp:/hp_model?serial=xxxxxxxx".
  One more supported all-in-one device.
  Several bug fixes (no Suse bugs).
- Updated to version 0.9.8:
  New PC send fax support via special CUPS backend (hpfax)
  and special HP-Fax-hplip.ppd PPD file
  and a new send fax UI (hp-sendfax).
  Some more supported printers.
  Several bug fixes (no Suse bugs).
* Wed Apr 26 2006 - jsmeix@suse.de
- Fixed PPDs for "LaserJet 5Si" and "LaserJet 5MP"
  (see Suse bugzilla bug #164991).
* Fri Feb 24 2006 - jsmeix@suse.de
- Fixed an array index underflow (for LJ1010, LJ1012)
  in ljfastraster.cpp (Suse Bugzilla #152720).
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Thu Jan 12 2006 - jsmeix@suse.de
- Set compiler flag "-fstack-protector-all" to build it with
  "Stack Protector" via a so called "canary" (requires gcc >= 4.1)
* Wed Jan 04 2006 - jsmeix@suse.de
- Moved /usr/lib[64]/libhpip.* library files to the hplip-hpijs
  sub-package because /usr/bin/hpijs requires libhpip but for
  special cases (e.g. for a minimal printing system) it should
  be possible to use only HPIJS without the rest of HPLIP.
* Tue Jan 03 2006 - jsmeix@suse.de
- Updated to version 0.9.7
  including the additional hplip-0.9.7-2.patch from HP.
* Thu Dec 22 2005 - ro@suse.de
- requires: PyQt -> python-qt
* Thu Dec 01 2005 - jsmeix@suse.de
- Removed unneeded KDE packages from "neededforbuild" since
  the new package python-qt was split from kdebindings3-python
  (see Suse bugzilla bug #135250).
* Mon Nov 28 2005 - jsmeix@suse.de
- Replaced requirement for the package kdebindings3-python
  by a generic requirement for the RPM capability PyQt
  to avoid needless dependencies to KDE libraries
  (see Suse bugzilla bug #135250).
* Tue Nov 22 2005 - jsmeix@suse.de
- Added -fno-strict-aliasing to the CXXFLAGS to avoid problems
  in ljfastraster.cpp (line 1213) and hpijs.cpp (lines 86, 223).
* Fri Nov 18 2005 - jsmeix@suse.de
- Updated to version 0.9.6
* Wed Sep 21 2005 - jsmeix@suse.de
- Updated to version 0.9.5
  including the additional hplip-0.9.5-3.patch from HP.
* Mon Sep 12 2005 - jsmeix@suse.de
- Several PPDs contain "600x600x2dpi" which is not allowed
  according to the Adobe PPD specification section 5.9
  and which is therefore simply replaced by "600x1200dpi"
  (see Suse bugzilla bug #116393).
* Mon Aug 29 2005 - jsmeix@suse.de
- Removed a non-working PPD.
- Fix "... is used uninitialized ..." warning.
* Tue Jul 26 2005 - jsmeix@suse.de
- Updated to version 0.9.4
- Removed obsolete fixes for missing class prototypes.
- Removed obsolete fixes for HP_Business_Inkjet_3000.ppd
- Added a fix for condrestart in /etc/init.d/hplip
* Tue May 31 2005 - jsmeix@suse.de
- Updated to version 0.9.3
* Tue May 24 2005 - jsmeix@suse.de
- Fixed missing class prototypes, otherwise it fails with
  "error: ISO C++ forbids declaration of 'xxx' with no type".
* Tue May 17 2005 - jsmeix@suse.de
- Fix "... is used uninitialized ..." warnings.
* Wed May 04 2005 - jsmeix@suse.de
- Updated to version 0.9.2 which does no longer need
  the "fix C" (i.e. hplip-0.8.8.diff) from below.
* Sun Apr 10 2005 - coolo@suse.de
- fix C
* Tue Mar 22 2005 - jsmeix@suse.de
- Added PreReq.
* Thu Mar 17 2005 - jsmeix@suse.de
- Fixed a bug in HP-DeskJet_3740-hpijs.ppd.gz:
  According to hpijs_readme.html the DeskJet 3740 belongs to the
  DJ3320 device class.
* Tue Mar 08 2005 - jsmeix@suse.de
- Added %%suse_update_desktop_file stuff for hp-toolbox.
- Moved %%{_libdir}/libsane-hpaio.* to %%{_libdir}/sane/
  instead of creating symlinks (see Tue Mar 1 11:15:33).
* Tue Mar 01 2005 - jsmeix@suse.de
- Added python-xml to RPM requirements because otherwise
  hpssd (i.e. /usr/share/hplip/hpssd.py) doesn't work.
- Create symlinks (via '%%triggerin -- sane') to all
  %%{_libdir}/libsane-hpaio.* so that SANE will find them.
- Added kdebindings3-python to RPM requirements because otherwise
  hp-toolbox (i.e. /usr/share/hplip/toolbox) doesn't work.
* Tue Feb 22 2005 - jsmeix@suse.de
- Changed default media size from Letter to A4
  if this is an available choice in the PPD.
* Tue Feb 15 2005 - jsmeix@suse.de
- Updated to version 0.8.8, for details see ChangeLog and
  http://hpinkjet.sourceforge.net/updates.php
- Removed the "compatibility"-links because they are not needed.
- Fixed basic stuff in the init script (needs further improvement).
- Source should be x86_64 clean (SUSE patch no longer needed).
* Tue Feb 01 2005 - jsmeix@suse.de
- Updated to version 0.8.7, for details see ChangeLog and
  http://hpinkjet.sourceforge.net/updates.php
- Added triggerin and postun scripts to add and remove
  the SANE backend "hpaio" in /etc/sane.d/dll.conf
- Replaced hplip-0.8.4-models.xml.diff by
  hplip-0.8.7-models.xml.diff because the "HP LaserJet 1220"
  is now in the models.xml file but the entry is buggy.
* Tue Jan 25 2005 - jsmeix@suse.de
- Branched the sub-package hplip-hpijs which contains only
  the plain HPIJS binary so that Ghostscript can require
  only this sub-package (without all the other stuff).
- Added a link to the toolbox program to have it accessible
  via the user's PATH.
- Added the usual 'rc'-link to the runlevel script.
- Added the following RPM requirements regarding printing:
  hplip requires hplip-hpijs and foomatic-filters
  hplip-hpijs requires ghostscript_any
  (There are no RPM requirements regarding scanning because
  HPLIP will be also used for plain printers.)
- Exchanged the destructive line for the cupsd in the runlevel script
  because cupsd runs as user lp and dies in case of a SIGHUP.
* Tue Jan 18 2005 - jsmeix@suse.de
- patch hplip-0.8.4-models.xml.diff adds the "HP LaserJet 1220"
  to the list of known models of the SANE backend "hpaio"
* Wed Jan 12 2005 - sf@suse.de
- add --libdir=%%_libdir to build on multilib archs
- add patch for cups search path for backends
* Thu Dec 02 2004 - jsmeix@suse.de
- initial version
